using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_Contabilidad._0_Modelos;
using Exferia_Contabilidad.General;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Contabilidad._3_Vistas.Listados
{
    public class ABS_Listado_CTA_DiarioCabecera_Descuadre : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_CTA_DiarioCabecera_Descuadre()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.id), "id", G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, false, false, "", null, false));
            
            //numeroAsiento
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.numeroAsiento), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.numeroAsiento), "Nº de Asiento", G_ENUM_TIPOSDATOS.LONG, false, 150, true, true, true, false, "", null, false));
            
            //Fecha
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.fecha), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.fecha), "Fecha", G_ENUM_TIPOSDATOS.DATETIME, false, 100, true, true, true, false, "", null, false));
            
            //Total_Debe
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.Total_Debe), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.Total_Debe), "Total debe", G_ENUM_TIPOSDATOS.DECIMAL, false, 120, true, true, true, false, "", null, false));
            
            //Total_Haber
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.Total_Haber), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.Total_Haber), "Total haber", G_ENUM_TIPOSDATOS.DECIMAL, false, 120, true, true, true, false, "", null, false));
            
            //Saldo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.Saldo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.Saldo), "Saldo", G_ENUM_TIPOSDATOS.DECIMAL, false, 120, true, true, true, false, "", null, false));
            
            //Delegacion
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_FICHERO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.Volcado_idPredefinidoFichero), nameof(CTA_PredefinidosFicheros), nameof(CTA_PredefinidosFicheros.id), nameof(CTA_PredefinidosFicheros.codigo), nameof(CTA_PredefinidosFicheros.descripcion), nameof(CTA_PredefinidosFicheros.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.Volcado_TipoFichero), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.Volcado_TipoFichero), "Fichero", G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, true, true, "", null, true, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_FICHERO));

            //Punteado
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.Punteado_Texto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.Punteado_Texto), "Punteado", G_ENUM_TIPOSDATOS.BOTON, false, 80, true, true, true, false, "", null, true));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_CTA_DIARIOCABECERA);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_CTA_DIARIOCABECERA + "_Descuadre";
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_CTA_DiarioCabecera_Listado_Modelo.numeroAsiento);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "1";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
